#define CR	.T.
#define NOCR .F.

local loChannelOne, loChannelTwo
* create output channels
loChannelOne=CREATEOBJECT('TextFile',CURDIR(),'First.txt',.T.)
loChannelTwo=CREATEOBJECT('TextFile',CURDIR(),'Second.txt',.T.)

loChannelOne.Additive=.F.
loChannelOne.Output('The Memoirs of Sherlock Holmes. Silver Blaze.',NOCR)
loChannelOne.Additive=.T.
loChannelOne.Output('',CR)
loChannelTwo.Additive=.F.
loChannelTwo.Output('The Return of Sherlock Holmes.',NOCR)
loChannelTwo.Additive=.T.
loChannelTwo.Output('The Adventury of the Empty House',CR)
loChannelTwo.Output('',CR)
* ... some code lines
loChannelOne.OpenOutput()
loChannelOne.ListOutput('...And so it happened that an hour '+;
                        'or so later I found myself in the',CR)
loChannelOne.ListOutput('corner of a first-class carriage flying '+;
                        'along en route for Exeter, while',CR)
loChannelOne.ListOutput('Sherlock Holmes, with his sharp, eager '+;
                        'face framed in his ear-flapped...',CR)  
loChannelOne.CloseOutput()   
* ... some code lines  
loChannelTwo.Output('                                           '+;
                    '... Even now, after this long interval, I',CR) 
loChannelTwo.Output('find myself thrilling as I think of it, '+;
                    'and feeling once more that sudden',CR)  
* ... some code lines   
loChannelTwo.Output('flood of joy, amazement, and incredulity which '+;
                    'utterly submerged my',CR) 
loChannelTwo.Output('mind...',CR)            
return

DEFINE CLASS textfile AS custom
	*-- File name for output channel
	filename = "output.txt"
	*-- Path
	path = ""
	
	Name = "textfile"

	*-- Output mode: .T. - add records, .F. - create new file
	additive = .F.

	*-- Channel status: .T.-opened, .F.-closed
	status = .F.

	*-- Internal status
	HIDDEN intstatus

	*-- Console state befor channel openning
	HIDDEN consol

	*-- Output line openning and closing channel
	PROCEDURE output
		lparameters lcString, llMode
		local lnParam
		lnParam=parameter()
		if lnParam < 2
			llMode=.T.
		endif
		this.OpenOutput()
		if llMode
			? lcString
		else
			?? lcString
		endif
		this.CloseOutput()
	ENDPROC

	*-- Open output channel
	PROCEDURE openoutput
		if this.Additive
			set alternate to (allt(this.Path)+'\'+allt(this.FileName)) ADDITIVE
		else 
			set alternate to (allt(this.Path)+'\'+allt(this.FileName)) 
		endif
		set alternate on
		set console off
		this.IntStatus=.T.
	ENDPROC

	*-- Close output channel
	PROCEDURE closeoutput
		set alternate off
		set alternate to
		set console on
		this.IntStatus=.F.
	ENDPROC

	PROCEDURE additive_assign
		LPARAMETERS vNewVal
		if this.Status
			this.CloseOutput()
		endif
		THIS.additive = m.vNewVal
	ENDPROC

	PROCEDURE filename_assign
		LPARAMETERS vNewVal
		if this.Status
			this.CloseOutput()
		endif
		THIS.filename = m.vNewVal
	ENDPROC

	PROCEDURE path_assign
		LPARAMETERS vNewVal
		if this.Status
			this.CloseOutput()
		endif
		THIS.path = m.vNewVal
	ENDPROC

	PROCEDURE status_assign
		LPARAMETERS vNewVal
		THIS.status = this.IntStatus
	ENDPROC

	*-- Output line does not changing channel state
	PROCEDURE listoutput
		lparameters lcString, llMode
		local lnParam
		lnParam=parameter()
		if lnParam < 2
			llMode=.T.
		endif
		if llMode
			? lcString
		else
			?? lcString
		endif
	ENDPROC

	PROCEDURE status_access
		RETURN this.IntStatus
	ENDPROC

	PROCEDURE release
		release this
	ENDPROC

	PROCEDURE Init
		lparameters lcPath,lcFile,llAdd
		if type('lcPath')='C'
			this.Path=lcPath
		endif
		if type('lcFile')='C'
			this.FileName=lcFile
		endif
		if type('llAdd')='L'
			this.Additive=llAdd
		endif
	ENDPROC
ENDDEFINE